/***************************************************************************
***************************************************************************/
#include <curses.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include "defs.h"
#include "misc.h"
#include "dir.h"
#include "snuggles.h"
#include "loop.h"
#include "file.h"
#include "dsp.h"

unsigned char snug_pos_real;
unsigned char snug_pos_hl;
unsigned char snug_pos_hl_old;
unsigned char snug_sd_option;
unsigned char pos;
int trim = TRIM;
int hold = FALSE;
tsong *song_ptr[MAX_SONGS];

int hot_key[127];
pthread_mutex_t lock;
extern WINDOW *looppad;
extern WINDOW *timerpad;
/***************************************************************************
****************************************************************************
****************************************************************************
*
* Sample editor
*
****************************************************************************
****************************************************************************
***************************************************************************/
void snug_show_help(void)
{
	hold = TRUE;
	clear_area(1,0,maxy, COLS);
  	move(1,6);
  	addstr("
F2	LOAD SESSION			
F3	SAVE SESSION	SHIFT-F3	SAVE LOOP TO FILE  
F4	LOAD FILE 	SHIFT-F4	CAPTURE OUTPUT TO FILE
F5	FRAME SET	SHIFT-F5	SET TRIM SIZE
F6	FRAME SPLIT  	SHIFT-F6	SET FAST FOREWARD/REWIND SPEED	
F7	FRAME DOUBLE  	SHIFT-F7	SET HOT KEY
F8	FRAME APPLY  	SHIFT-F8	CHANGE SAVE DIRECTORY
F9	SET START	SHIFT-F9	LOAD TO RAM  		
F10	SET END    	SHIFT-F10	SCREEN ESCAPE		
F11	INSERT ENTRY   	
F12	COPY ENTRY     		
PAGEUP/PAGEDN	FAST FOREWARD/REVERSE
+,-		INCREMENT/DECREMENT HIGHLIGHTED VALUE
/,*		INCREMENT/DECREMENT SAMPLE START POSITION
HOME		RETURN TO START POSITION
SPACEBAR	PLAY/PAUSE
ENTER		EDIT HIGHLIGHTED VALUE

Programmed by DAC TELECO
http://www.kdvs.org/~teleco
teleco@kdvs.org
");		
	getch();
	hold = FALSE;
}
void wclear_area(WINDOW *win,int y1,int x1,int y2,int x2)
{
  register int a;
  for(y1 = y1;y1 <= y2;y1++)
    for(a = x1;a <= x2;a++)
    {
      wmove(win,y1,a);
      waddch(win,' ');
    }
}

void update_pad(void){
	if (hold == FALSE){
		pthread_mutex_lock(&lock);
		prefresh(looppad,0,0,3,0,LINES-2,COLS-6);
		prefresh(timerpad,0,0,3,COLS-5,LINES-2,COLS-1);
		move(0,0);
		pthread_mutex_unlock(&lock);
	}
}
void snug_display_bg(void)
{
  register int y;
  register int amaxy = maxy ;
char str[10] = "";

  display_topbar();

  set_colour(COL_TITLE);
  move(1,0);
  addstr("Press F1 for HELP");
  clear_area(2,0,2,79);
  clear_area(amaxy,0,amaxy,79);

  move(2,1);
  addstr("No");
  move(2,4);
  addstr("Sample Name");
  move(2,25);
  addstr("Start");
  move(2,35);
  addstr("End");
  move(2,44);
  addstr("Vol:");
  move(2,53);
  addstr("Length");
  move(2,61);
  addch('L');
  move(2,63);
  addstr("rate");
  move(2,COLS-4);
  addstr("Pos");

  set_colour(COL_TEXT2);
  y = strlen(session_filename);
  if(y > 56) y = 56;
  move(1,80 - (6 + y));
  addstr("SONG: ");
  addnstr(session_filename,56);
  amaxy = maxy -1;
  move(1,25);
  addstr("Trim: ");
	sprintf(str,"%i",trim);
  	set_colour(COL_TEXT);
  addstr(str);
  set_colour(COL_TEXT2);
  move(1,44);
  addstr("Fast_speed: ");
	sprintf(str,"%i",fast_speed);
  	set_colour(COL_TEXT);
  addstr(str);
  move(amaxy,1);
  addstr("Save Directory: ");
  addnstr(save_directory,56);
}

/***************************************************************************
*
***************************************************************************/
void snug_hl_bar(unsigned char pl,unsigned char x)
{
  if((snug_pos_hl == pl) && (snug_sd_option == x))
  {
    wattron(looppad,A_REVERSE);
  }
  else
  {
    wattroff(looppad,A_REVERSE);
  }
}

void format_time (char *str, long value, tfileinfo *info){

	int hr, mn, sc;

	hr = (value)/ 3600 / info->srate/info->blkalign;
	mn = ((value) / 60 / info->srate) % 60 + 1;
	sc = ((value) / info->srate ) % 60 + 1;

	sprintf(str,"%.2d:%.2d", mn - 1, sc - 1);
	
}

void update_curpos(int no, long curpos)
{
  	char dstr[] = "        ";
	pthread_mutex_lock(&lock);
	format_time(dstr,curpos,&song_ptr[no]->info);
  	wmove(timerpad,no-snug_pos_real,0);
	if (song_ptr[no]->loop.playing != -1)
  		wattrset(timerpad,COLOR_PAIR(COL_TEXT2));
  	waddstr(timerpad,dstr);
  	wattrset(timerpad,COLOR_PAIR(COL_TEXT));
	pthread_mutex_unlock(&lock);
}

void snug_dis_samentry(unsigned char hlpos)
{
  	char bstr[] = "  ";
  	char dstr[] = "        ";
  	char *noname = "                   ";
  	register int no = snug_pos_real + hlpos;

  	wattroff(looppad,A_REVERSE);
  	set_colour(COL_TEXT);
	wmove(looppad,hlpos,0);
	wclear_area(looppad,hlpos,0,hlpos, COLS-6);

	if (song_ptr[no] != NULL)
	{
		if (song_ptr[no]->hk != -1){
  			wmove(looppad,hlpos,1);
  			sprintf(bstr,"%c",song_ptr[no]->hk);
  			waddstr(looppad,bstr);
		}
		else{
  			sprintf(bstr,"%i",(int)no+1);
  			wmove(looppad,hlpos,1);
  			waddstr(looppad,bstr);
		}
		if (song_ptr[no]->loop.buf != NULL)
  			wattrset(looppad,COLOR_PAIR(COL_TITLE));
		else
  			wattrset(looppad,COLOR_PAIR(COL_TEXT));
		if (song_ptr[no]->loop.playing == -1)
			update_curpos(no ,song_ptr[no]->loop.curpos);
  		snug_hl_bar(hlpos,0);
  		wmove(looppad,hlpos,4);
  		waddnstr(looppad,song_ptr[no]->sname,19);

		snug_hl_bar(hlpos,1);
  		sprintf(dstr,"%i",(int)song_ptr[no]->loop.startpos);
  		wmove(looppad,hlpos,25);
  		waddstr(looppad,dstr);

  		snug_hl_bar(hlpos,2);
  		sprintf(dstr,"%i",(int)song_ptr[no]->loop.endpos);
  		wmove(looppad,hlpos,35);
  		waddstr(looppad,dstr);

  		snug_hl_bar(hlpos,3);
  		sprintf(dstr,"%.3f",song_ptr[no]->loop.vol);
  		wmove(looppad,hlpos,45);
  		waddstr(looppad,dstr);

  		wattroff(looppad,A_REVERSE);
		format_time(dstr,song_ptr[no]->loop.endpos-song_ptr[no]->loop.startpos,&song_ptr[no]->info);
  		wmove(looppad,hlpos,52);
  		waddstr(looppad,dstr);

  		snug_hl_bar(hlpos,4);
  		wmove(looppad,hlpos,61);
  		sprintf(bstr,"%i",(int)song_ptr[no]->loop.loop);
  		waddstr(looppad,bstr);

  		snug_hl_bar(hlpos,5);
  		wmove(looppad,hlpos,63);
  		sprintf(dstr,"%i",(int)song_ptr[no]->info.srate);	
  		waddstr(looppad,dstr);

	}
	else
	{
  		sprintf(bstr,"%i",(int)no+1);
  		wmove(looppad,hlpos,1);
  		waddstr(looppad,bstr);
  		snug_hl_bar(hlpos,snug_sd_option);
  		wmove(looppad,hlpos,4);
  		waddnstr(looppad,noname,19);
  		wattroff(looppad,A_REVERSE);
		pthread_mutex_lock(&lock);
  		wmove(timerpad,hlpos,0);
  		waddstr(timerpad,"     ");
		pthread_mutex_unlock(&lock);
	}
}

/***************************************************************************
* miwi 27/05/96
***************************************************************************/
void snug_display_all(void)
{
  	register int no;

  	for(no = 0;no < (maxy - 4);no++)
    		snug_dis_samentry(no);
  	snug_pos_hl_old = snug_pos_hl;
}

void snug_move_hl(void)
{
  snug_dis_samentry(snug_pos_hl_old);
  snug_dis_samentry(snug_pos_hl);
  snug_pos_hl_old = snug_pos_hl;
}

/***************************************************************************
* miwi 27/05/96
***************************************************************************/
void snug_cursor_up(void)
{
  if(snug_pos_hl > 0)
  {
    snug_pos_hl--;
    snug_move_hl();
    snug_dis_samentry(snug_pos_hl);
    update_pad();
  }
  else if (snug_pos_real > 0)
  {
    snug_pos_real--;
    snug_display_all();
    update_pad();
  }
}

void snug_cursor_down(void)
{
  if(snug_pos_hl < (maxy - 5))
  {
    snug_pos_hl++;
    snug_move_hl();
    snug_dis_samentry(snug_pos_hl);
    update_pad();
  }
  else
  {
    if(snug_pos_real < ((MAX_SONGS) - 4 - maxy)) {
		snug_pos_real++;
    	snug_display_all();
    	update_pad();
	}
  }
}

/***************************************************************************
*
***************************************************************************/
int reload_sample(int no)
{
	if(song_ptr[no] != NULL)
	{
		song_ptr[no]->loop.buf =
		load_ram( song_ptr[no] );
		ch = ' ';
		return (0);
	}

	else {
		ch = ' ';
		return (-1);
	}

}


/***************************************************************************
*
***************************************************************************/
void *get_name(void)
{
	char outname[40];
	char *path;
	path = (char *)malloc(256);
  	move(maxy-1,0);
  	addstr("Enter filename: ");

/*get output name*/
	echo();
	getstr(outname);
	noecho();
  	clear_area(maxy-1,0,maxy-1,79);
	strcpy(path, save_directory);
	strcat(path,"/");
	strcat(path,outname);
	return path;
}
void save_file(int no)
{
	char *path;
	path = get_name();
	do_output(path,song_ptr[no]);
	free(path);
    snug_display_all();
	update_screen();
}
/*
void capture_switch(int no)
{
	char *path;
	if(rec == -1){
		path = get_name();
		open_out(path,song_ptr[no]);
	}
	else 
		close_out();
}
*/
void snug_insert_sam(void)
{
	register int x,no = snug_pos_real + snug_pos_hl;
	for( x = MAX_SONGS-1 ; x > no ; x-- )
	{
		fullpath[x] = fullpath[x - 1];
		song_ptr[x] = song_ptr[x - 1];
	}

	if (chdir(fullpath[no]) != -1){
		load_snug(no + 1, song_ptr[no]->title);
	switch(ch)
	{
		case FC_INS_ENTRY:
			if (song_ptr[no]->loop.endpos*song_ptr[no]->info.blkalign 
											< song_ptr[no]->info.datalen)
				song_ptr[no + 1]->loop.startpos = song_ptr[no]->loop.endpos;
			else
				song_ptr[no + 1]->loop.startpos = song_ptr[no]->loop.startpos;
		break;
		case FC_COPY_ENTRY:
			song_ptr[no + 1]->loop.endpos = song_ptr[no]->loop.endpos;
			song_ptr[no + 1]->loop.startpos = song_ptr[no]->loop.startpos;
		break;
	}
	fseek(song_ptr[no+1]->loop.fp,song_ptr[no+1]->loop.startpos*
			song_ptr[no+1]->info.blkalign,SEEK_SET);
	song_ptr[no + 1]->loop.curpos = song_ptr[no + 1]->loop.startpos;
	snug_display_all();
 	update_pad();
	}
}

void snug_delete_sam(void)
{
  register int x, no = snug_pos_real + snug_pos_hl;
	if (song_ptr[no] != NULL)
		free_sample(&song_ptr[no]->loop);
	if (fullpath[no] != NULL){
		fclose(song_ptr[no]->loop.fp);
		free( fullpath[no] );
		fullpath[no] = NULL;
		song_ptr[no]->pathsize = 0;
		free(song_ptr[no]);
	}
	
  for(x = no;x < MAX_SONGS;x++)
  {
//    memcpy(&snug_song[x],&snug_song[x + 1],sizeof(tsong));
	fullpath[x] = fullpath[x+1];
    song_ptr[x] = song_ptr[x + 1];
  }
  snug_display_all();
  update_pad();
}

int set_hot_key(int songno){
	int no=-1;
	if(ch>=49){
		if((ch>=48)&&(ch<=57)){
			no=ch-48;
		}
		else if((ch>=97)&&(ch<=122)){
			no=ch-87;
		}
		if(no != -1){
			hot_key[no]=songno;
			return no;
		}
		else
			return -1;
	}
	else 
		return -1;
}

void do_hot_key(void){
	if (hot_key[ch] != -1){
		if (hot_key[ch] < snug_pos_real){
			snug_pos_real = hot_key[ch];
			snug_pos_hl = 0;
  			snug_display_all();
  			update_pad();
		}
		else if (snug_pos_hl != hot_key[ch]){
			snug_pos_hl = hot_key[ch] - snug_pos_real;
    		snug_move_hl();
    		snug_dis_samentry(snug_pos_hl);
    		update_pad();
		}
		play_file(hot_key[ch],1);
	}	
	ch = 0;
}
/***************************************************************************
*
***************************************************************************/
void snug_edit_sd(void)
{
  register long x;
  char str[20] = "";
  int no = snug_pos_real + snug_pos_hl;

if (song_ptr[no] != NULL){
  	switch(snug_sd_option)
  	{
    	case 0:
		switch(ch)
		{
			case FC_SNUG_ED_ATTR:
				pthread_mutex_lock(&lock);
	      			get_string(3 + snug_pos_hl,4,str,19);
					pthread_mutex_unlock(&lock);
    	  			for(x = 0;x < 19;x++)
      				if(str[x])
        				song_ptr[no]->sname[x] = str[x];
      				else
        				song_ptr[no]->sname[x] = 32;
					break;
			}
   		break;
    	case 1:
			switch(ch)
			{
				case FC_TRIM_DOWN:
					if ( song_ptr[no]->loop.startpos >= 
							song_ptr[no]->info.datastart + trim ){
							song_ptr[no]->loop.startpos = 
								song_ptr[no]->loop.startpos - trim;
					}
		    	break;
				case FC_TRIM_UP:
					if ( song_ptr[no]->loop.startpos <= 
							song_ptr[no]->loop.endpos - trim ){
						song_ptr[no]->loop.startpos = 
							song_ptr[no]->loop.startpos + trim ;
					}
		    	break;
	    		case FC_SNUG_ED_ATTR:
					pthread_mutex_lock(&lock);
    	  			get_string(3 + snug_pos_hl,25,str,8);
					pthread_mutex_unlock(&lock);
      				x = atol(str);
					if (( x < song_ptr[no]->loop.endpos)&&(x >= 0))
						song_ptr[no]->loop.startpos = x;
		    	break;
			}		
      	break;		
    	case 2:
			switch(ch)
			{
				case FC_TRIM_DOWN:
				if ( song_ptr[no]->loop.endpos >= 
						song_ptr[no]->loop.startpos + trim  ){
					song_ptr[no]->loop.endpos = 
						song_ptr[no]->loop.endpos - trim ;
				}
			break;
				case FC_TRIM_UP:
				if ( song_ptr[no]->loop.endpos <= song_ptr[no]->info.datalen - trim  ){
					song_ptr[no]->loop.endpos = song_ptr[no]->loop.endpos + trim ;
				}
			break;
    		case FC_SNUG_ED_ATTR:
				pthread_mutex_lock(&lock);
      			get_string(3 + snug_pos_hl,35,str,8);
				pthread_mutex_unlock(&lock);
      			x = atol(str);
				if (( x > song_ptr[no]->loop.startpos)&&(x <= 
						song_ptr[no]->info.datalen))
					song_ptr[no]->loop.endpos = x;
			break;
			}		
		break;		
    	case 3:
			switch(ch)
			{
				case FC_TRIM_DOWN:
					if ( song_ptr[no]->loop.vol >= 0.010  ){
						song_ptr[no]->loop.vol = song_ptr[no]->loop.vol - 0.010;
					}
		    	break;
				case FC_TRIM_UP:		
					if ( song_ptr[no]->loop.vol <= 10.00 ){
						song_ptr[no]->loop.vol = song_ptr[no]->loop.vol + 0.010 ;
					}
		    	break;
	    		case FC_SNUG_ED_ATTR:
					pthread_mutex_lock(&lock);
    	  			get_string(3 + snug_pos_hl,25,str,8);
					pthread_mutex_unlock(&lock);
      				x = atol(str);
					if (( x < song_ptr[no]->loop.endpos)&&(x >= 0))
						song_ptr[no]->loop.startpos = x;
		    	break;
			}		
      	break;		
		case 4:	
			if (song_ptr[no]->loop.loop == NOLOOP)
				song_ptr[no]->loop.loop = LOOP;
			else
				song_ptr[no]->loop.loop = NOLOOP;
		break;
    	case 5:
			switch(ch)
			{
				case FC_TRIM_DOWN:
					if ( song_ptr[no]->info.srate == 22050 )
						song_ptr[no]->info.srate = 11025;
					if ( song_ptr[no]->info.srate == 44100 )
						song_ptr[no]->info.srate = 22050;
		    	break;
				case FC_TRIM_UP:		
					if ( song_ptr[no]->info.srate == 22050 )
						song_ptr[no]->info.srate = 44100;
					if ( song_ptr[no]->info.srate == 11025 )
						song_ptr[no]->info.srate = 22050;
		    	break;
	    		case FC_SNUG_ED_ATTR:
					pthread_mutex_lock(&lock);
    	  			get_string(3 + snug_pos_hl,25,str,8);
					pthread_mutex_unlock(&lock);
      				x = atol(str);
					if (( x < song_ptr[no]->loop.endpos)&&(x >= 0))
						song_ptr[no]->loop.startpos = x;
		    	break;
			}		
      	break;		

	}
	snug_dis_samentry(snug_pos_hl);
	update_pad();
	ch = 0;
}
}

void snug_main(void)
{
	long retval;
  	char str[20] = "";
	pos = snug_pos_real + snug_pos_hl;
  	switch(ch)
  	{
    	case FC_SNUG_HELP:
      		snug_show_help();
      		main_editor_dis_bg();
      	break;
    	case FC_SET_TRIM:
			pthread_mutex_lock(&lock);
      		get_string(1,33,str,8);
			pthread_mutex_unlock(&lock);
      		trim = atol(str);
  			attroff(A_REVERSE);
			sprintf(str,"%i",trim);
  			move(1,33);
  			addstr(str);
  			addstr("      ");
		break;
    	case FC_SET_HK:
			if (song_ptr[pos] != NULL){
  				set_colour(COL_TEXT2);
  				move(maxy-1,COLS-11);
  				addstr("Set hot key");
      			ch = getch();
				if((song_ptr[hot_key[ch]] != NULL)&&(hot_key[ch] != -1))
					song_ptr[hot_key[ch]]->hk = -1;
				hot_key[ch]=pos;
				song_ptr[pos]->hk = ch;
  				move(maxy-1,COLS-11);
  				addstr("F1 for HELP");
  				set_colour(COL_TEXT);
      			snug_dis_samentry(snug_pos_hl);
				update_pad();
      			update_screen();
			}
		break;
    	case FC_SET_FAST:
			pthread_mutex_lock(&lock);
      		get_string(1,56,str,3);
			pthread_mutex_unlock(&lock);
      		fast_speed = atol(str);
  			attroff(A_REVERSE);
  			move(1,56);
			sprintf(str,"%i",fast_speed);
  			addstr(str);
  			addstr("   ");
		break;
		case KEY_FRAMEUP:
			if ( song_ptr[pos]->loop.startpos >= 
					song_ptr[pos]->info.datastart + trim ){
				song_ptr[pos]->loop.startpos = 
					song_ptr[pos]->loop.startpos - trim;
				song_ptr[pos]->loop.endpos = 
					song_ptr[pos]->loop.endpos - trim;
				snug_dis_samentry(snug_pos_hl);
      			update_pad();
			}
		break;
		case KEY_FRAMEDOWN:
			if ( song_ptr[pos]->loop.startpos <= 
				song_ptr[pos]->loop.endpos - trim ){
				song_ptr[pos]->loop.startpos = 
					song_ptr[pos]->loop.startpos + trim ;
				song_ptr[pos]->loop.endpos = 
					song_ptr[pos]->loop.endpos + trim;
				snug_dis_samentry(snug_pos_hl);
      			update_pad();
			}
		break;
   	case FC_SNUG_ED_ATTR:
    case FC_TRIM_UP:
    case FC_TRIM_DOWN:
      snug_edit_sd();
      break;
    case FC_ARROW_UP:
      snug_cursor_up();
      break;
    case FC_ARROW_DN:
      snug_cursor_down();
      break;
    case FC_ARROW_LEFT:
      if(snug_sd_option > 0) snug_sd_option--;
      snug_dis_samentry(snug_pos_hl);
      update_pad();
      break;
    case FC_ARROW_RIGHT:
      if(snug_sd_option < 5) snug_sd_option++;
      snug_dis_samentry(snug_pos_hl);
      update_pad();
      break;
    case FC_LOAD_FILE:
		hold = TRUE;
      if(get_sam_file_name(sample_directory,&sam_fpos_real,&sam_fpos_hl,
        &sam_fpos_hl_old,sam_filename) != -1)
      {
        if(chdir(sample_directory) == -1)
          ferr_message("Couldn't locate sample directory.");
        else
        {
          load_snug(pos,sam_filename);
          if(ferr_val != FERR_OK)
            ferr_message(ferr_messages[ferr_val]);
        }
      }
		hold=FALSE;
      main_editor_dis_bg();
      break;
    case FC_DEL_ENTRY:
      snug_delete_sam();
      break;
    case FC_INS_ENTRY:
	case FC_COPY_ENTRY:
      snug_insert_sam();
      break;
    case FC_PAGEUP:
		if(song_ptr[pos] != NULL){
      	if ( (retval = fast_forward(&song_ptr[pos]->loop,&song_ptr[pos]->info)) != -1){
			song_ptr[pos]->loop.curpos = retval;
      		snug_dis_samentry(snug_pos_hl);
      		update_pad();
		}
		}
      	break;
    case FC_PAGEDOWN:
		if(song_ptr[pos] != NULL){
      	if ( (retval = fast_rewind(&song_ptr[pos]->loop,&song_ptr[pos]->info)) != -1){
			song_ptr[pos]->loop.curpos = retval;
      		snug_dis_samentry(snug_pos_hl);
      		update_pad();
		}
		}
      	break;
	case FC_SNUG_HOME :	
		if(song_ptr[pos] != NULL){
		if ( (retval = go_home(&song_ptr[pos]->loop,&song_ptr[pos]->info)) != -1){
			song_ptr[pos]->loop.curpos = retval;
      		snug_dis_samentry(snug_pos_hl);
      		update_pad();
		}
		}
		break;
    case FC_SET_START:
		if(song_ptr[pos] != NULL){
      	if ( (retval = set_start(&song_ptr[pos]->loop,&song_ptr[pos]->info)) != -1){
			song_ptr[pos]->loop.curpos = song_ptr[pos]->loop.startpos = retval;
      		snug_dis_samentry(snug_pos_hl);
      		update_pad();
		}
		}
      	break;
    case FC_SET_END:
		if(song_ptr[pos] != NULL){
      		if ((retval = set_end(&song_ptr[pos]->loop,&song_ptr[pos]->info))
					!=-1){
				song_ptr[pos]->loop.curpos = song_ptr[pos]->loop.endpos = retval; 
      			snug_dis_samentry(snug_pos_hl);
      			update_pad();
			}
		}
      	break;
    case FC_SNUG_FRAME_SPLIT:
		frame = (int) frame/2;
		break;
    case FC_SNUG_FRAME_DOUBLE:
		frame = frame*2;
		break;
    case FC_SNUG_FRAME_SET:
		if(song_ptr[pos] != NULL)
      		set_frame(&song_ptr[pos]->loop,&song_ptr[pos]->info); 
		break;
    case FC_SNUG_FRAME_APPLY:
		if(song_ptr[pos] != NULL)
      		do_frame(&song_ptr[pos]->loop,&song_ptr[pos]->info); 
      	snug_dis_samentry(snug_pos_hl);
      	update_pad();
		break;
    case FC_LOAD_TO_RAM:
		if (song_ptr[pos] != NULL){
			if(	load_ram(song_ptr[pos]) != NULL)
			{
      			snug_dis_samentry(snug_pos_hl);
    			update_screen();
			}
			else
				ferr_message("Couldn't load to RAM");
		}
      	break;
    case FC_SNUG_PLAY:
      	play_file(pos,0);
      	break;
    case FC_SNUG_SAVE:
      	save_file(snug_pos_real + snug_pos_hl);
      	break;
/*
    case FC_SNUG_CAPTURE:
		capture_switch(snug_pos_real + snug_pos_hl);
      	break;
*/
    default:
		global_keys();
		do_hot_key();
    break;
  }
}
